diff --git a/drivers/common/mlx5/mlx5_prm.h b/drivers/common/mlx5/mlx5_prm.h
index aa0b622ca2..bced5a59dd 100644
--- a/drivers/common/mlx5/mlx5_prm.h
+++ b/drivers/common/mlx5/mlx5_prm.h
@@ -5352,6 +5352,21 @@ enum mlx5_parse_graph_arc_node_index {
 	MLX5_GRAPH_ARC_NODE_PROGRAMMABLE = 0x1f,
 };
 
+enum mlx5_packet_reformat_context_reformat_type {
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L2_TO_L2_TUNNEL = 0x2,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L2_TO_L3_TUNNEL = 0x4,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_ADD_ESP_TRANSPORT_OVER_IPV4 = 0x5,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L2_TO_L3_ESP_TUNNEL = 0x6,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_ADD_ESP_TRANSPORT_OVER_UDPV4 = 0x7,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_DEL_ESP_TRANSPORT = 0x8,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L3_ESP_TUNNEL_TO_L2 = 0x9,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_DEL_ESP_TRANSPORT_OVER_UDP = 0xA,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_ADD_ESP_TRANSPORT_OVER_IPV6 = 0xB,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_ADD_ESP_TRANSPORT_OVER_UDPV6 = 0xC,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_ADD_NISP_TNL = 0xD,
+	MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_REMOVE_NISP_TNL = 0xE,
+};
+
 #define MLX5_PARSE_GRAPH_FLOW_SAMPLE_MAX 8
 #define MLX5_PARSE_GRAPH_IN_ARC_MAX 8
 #define MLX5_PARSE_GRAPH_OUT_ARC_MAX 8
diff --git a/drivers/net/mlx5/hws/mlx5dr_action.c b/drivers/net/mlx5/hws/mlx5dr_action.c
index 6b62111593..11a7c58925 100644
--- a/drivers/net/mlx5/hws/mlx5dr_action.c
+++ b/drivers/net/mlx5/hws/mlx5dr_action.c
@@ -1703,6 +1703,44 @@ mlx5dr_action_create_modify_header(struct mlx5dr_context *ctx,
 	return NULL;
 }
 
+static struct mlx5dr_devx_obj *
+mlx5dr_action_dest_array_process_reformat(struct mlx5dr_context *ctx,
+					  enum mlx5dr_action_type type,
+					  void *reformat_data,
+					  size_t reformat_data_sz)
+{
+	struct mlx5dr_cmd_packet_reformat_create_attr pr_attr = {0};
+	struct mlx5dr_devx_obj *reformat_devx_obj;
+
+	if (!reformat_data || !reformat_data_sz) {
+		DR_LOG(ERR, "Empty reformat action or data");
+		rte_errno = EINVAL;
+		return NULL;
+	}
+
+	switch (type) {
+	case MLX5DR_ACTION_TYP_REFORMAT_L2_TO_TNL_L2:
+		pr_attr.type = MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L2_TO_L2_TUNNEL;
+		break;
+	case MLX5DR_ACTION_TYP_REFORMAT_L2_TO_TNL_L3:
+		pr_attr.type = MLX5_PACKET_REFORMAT_CONTEXT_REFORMAT_TYPE_L2_TO_L3_TUNNEL;
+		break;
+	default:
+		DR_LOG(ERR, "Invalid value for reformat type");
+		rte_errno = EINVAL;
+		return NULL;
+	}
+	pr_attr.reformat_param_0 = 0;
+	pr_attr.data_sz = reformat_data_sz;
+	pr_attr.data = reformat_data;
+
+	reformat_devx_obj = mlx5dr_cmd_packet_reformat_create(ctx->ibv_ctx, &pr_attr);
+	if (!reformat_devx_obj)
+		return NULL;
+
+	return reformat_devx_obj;
+}
+
 struct mlx5dr_action *
 mlx5dr_action_create_dest_array(struct mlx5dr_context *ctx,
 				size_t num_dest,
@@ -1710,6 +1748,7 @@ mlx5dr_action_create_dest_array(struct mlx5dr_context *ctx,
 				uint32_t flags)
 {
 	struct mlx5dr_cmd_set_fte_dest *dest_list = NULL;
+	struct mlx5dr_devx_obj *packet_reformat = NULL;
 	struct mlx5dr_cmd_ft_create_attr ft_attr = {0};
 	struct mlx5dr_cmd_set_fte_attr fte_attr = {0};
 	struct mlx5dr_cmd_forward_tbl *fw_island;
@@ -1796,6 +1835,21 @@ mlx5dr_action_create_dest_array(struct mlx5dr_context *ctx,
 				dest_list[i].destination_id = dests[i].dest->devx_dest.devx_obj->id;
 				fte_attr.action_flags |= MLX5_FLOW_CONTEXT_ACTION_FWD_DEST;
 				break;
+			case MLX5DR_ACTION_TYP_REFORMAT_L2_TO_TNL_L2:
+			case MLX5DR_ACTION_TYP_REFORMAT_L2_TO_TNL_L3:
+				packet_reformat = mlx5dr_action_dest_array_process_reformat
+							(ctx,
+							 *action_type,
+							 dests[i].reformat.reformat_data,
+							 dests[i].reformat.reformat_data_sz);
+				if (!packet_reformat)
+					goto free_dest_list;
+
+				dest_list[i].ext_flags |= MLX5DR_CMD_EXT_DEST_REFORMAT;
+				dest_list[i].ext_reformat = packet_reformat;
+				ft_attr.reformat_en = true;
+				fte_attr.extended_dest = 1;
+				break;
 			default:
 				DR_LOG(ERR, "Unsupported action in dest_array");
 				rte_errno = ENOTSUP;
@@ -1819,8 +1873,9 @@ mlx5dr_action_create_dest_array(struct mlx5dr_context *ctx,
 		goto free_action;
 
 	action->dest_array.fw_island = fw_island;
+	action->dest_array.num_dest = num_dest;
+	action->dest_array.dest_list = dest_list;
 
-	simple_free(dest_list);
 	return action;
 
 free_action:
@@ -1828,6 +1883,10 @@ mlx5dr_action_create_dest_array(struct mlx5dr_context *ctx,
 destroy_fw_island:
 	mlx5dr_cmd_forward_tbl_destroy(fw_island);
 free_dest_list:
+	for (i = 0; i < num_dest; i++) {
+		if (dest_list[i].ext_reformat)
+			mlx5dr_cmd_destroy_obj(dest_list[i].ext_reformat);
+	}
 	simple_free(dest_list);
 	return NULL;
 }
@@ -1917,6 +1976,12 @@ static void mlx5dr_action_destroy_hws(struct mlx5dr_action *action)
 	case MLX5DR_ACTION_TYP_DEST_ARRAY:
 		mlx5dr_action_destroy_stcs(action);
 		mlx5dr_cmd_forward_tbl_destroy(action->dest_array.fw_island);
+		for (i = 0; i < action->dest_array.num_dest; i++) {
+			if (action->dest_array.dest_list[i].ext_reformat)
+				mlx5dr_cmd_destroy_obj
+					(action->dest_array.dest_list[i].ext_reformat);
+		}
+		simple_free(action->dest_array.dest_list);
 		break;
 	case MLX5DR_ACTION_TYP_REFORMAT_TNL_L3_TO_L2:
 	case MLX5DR_ACTION_TYP_MODIFY_HDR:
diff --git a/drivers/net/mlx5/hws/mlx5dr_action.h b/drivers/net/mlx5/hws/mlx5dr_action.h
index efe07c9d47..582a38bebc 100644
--- a/drivers/net/mlx5/hws/mlx5dr_action.h
+++ b/drivers/net/mlx5/hws/mlx5dr_action.h
@@ -153,6 +153,8 @@ struct mlx5dr_action {
 				} devx_dest;
 				struct {
 					struct mlx5dr_cmd_forward_tbl *fw_island;
+					size_t num_dest;
+					struct mlx5dr_cmd_set_fte_dest *dest_list;
 				} dest_array;
 			};
 		};
diff --git a/drivers/net/mlx5/hws/mlx5dr_cmd.c b/drivers/net/mlx5/hws/mlx5dr_cmd.c
index 22f7c6b019..781de40c02 100644
--- a/drivers/net/mlx5/hws/mlx5dr_cmd.c
+++ b/drivers/net/mlx5/hws/mlx5dr_cmd.c
@@ -169,7 +169,9 @@ mlx5dr_cmd_set_fte(struct ibv_context *ctx,
 	uint32_t *in;
 	uint32_t i;
 
-	dest_entry_sz = MLX5_ST_SZ_BYTES(dest_format);
+	dest_entry_sz = fte_attr->extended_dest ?
+			MLX5_ST_SZ_BYTES(extended_dest_format) :
+			MLX5_ST_SZ_BYTES(dest_format);
 	total_dest_sz = dest_entry_sz * fte_attr->dests_num;
 	inlen = align((MLX5_ST_SZ_BYTES(set_fte_in) + total_dest_sz), DW_SIZE);
 	in = simple_calloc(1, inlen);
@@ -192,6 +194,7 @@ mlx5dr_cmd_set_fte(struct ibv_context *ctx,
 	in_flow_context = MLX5_ADDR_OF(set_fte_in, in, flow_context);
 	MLX5_SET(flow_context, in_flow_context, group_id, group_id);
 	MLX5_SET(flow_context, in_flow_context, flow_source, fte_attr->flow_source);
+	MLX5_SET(flow_context, in_flow_context, extended_destination, fte_attr->extended_dest);
 	MLX5_SET(set_fte_in, in, ignore_flow_level, fte_attr->ignore_flow_level);
 
 	action_flags = fte_attr->action_flags;
@@ -230,6 +233,11 @@ mlx5dr_cmd_set_fte(struct ibv_context *ctx,
 					 dest->destination_type);
 				MLX5_SET(dest_format, in_dests, destination_id,
 					 dest->destination_id);
+				if (dest->ext_flags & MLX5DR_CMD_EXT_DEST_REFORMAT) {
+					MLX5_SET(dest_format, in_dests, packet_reformat, 1);
+					MLX5_SET(extended_dest_format, in_dests, packet_reformat_id,
+						 dest->ext_reformat->id);
+				}
 				break;
 			default:
 				rte_errno = EOPNOTSUPP;
diff --git a/drivers/net/mlx5/hws/mlx5dr_cmd.h b/drivers/net/mlx5/hws/mlx5dr_cmd.h
index 6f4aa3e320..28e5ea4726 100644
--- a/drivers/net/mlx5/hws/mlx5dr_cmd.h
+++ b/drivers/net/mlx5/hws/mlx5dr_cmd.h
@@ -14,6 +14,7 @@ struct mlx5dr_cmd_set_fte_dest {
 	uint8_t destination_type;
 	uint32_t destination_id;
 	enum mlx5dr_cmd_ext_dest_flags ext_flags;
+	struct mlx5dr_devx_obj *ext_reformat;
 	uint16_t esw_owner_vhca_id;
 };
 
@@ -21,6 +22,7 @@ struct mlx5dr_cmd_set_fte_attr {
 	uint32_t action_flags;
 	uint8_t ignore_flow_level;
 	uint8_t flow_source;
+	uint8_t extended_dest;
 	uint8_t encrypt_decrypt_type;
 	uint32_t encrypt_decrypt_obj_id;
 	uint32_t packet_reformat_id;